/* [pl0_pim.c] Parser table for 'pl0'  */



#include "prs.h"

#include "prs_imp.h"


static string pl0_SNames[] = {
  "Tok", "Int", "Ide", "Com", "fun", 
  "(", ",", ")", "=", "run", 
  "if", "then", "else", "<", "+", 
  "-", "*", "/", "Program", "_List1", 
  "_List1_0", "_List2", "_List2_0", "Dfn", "_List3", 
  "_List3_0", "Run", "Exp", "Exp1", "Exp2", 
  "Exp3", "Exp4", "_List4", "_List4_0"
};

static int pl0_StartIds[] = {
  18
};

static int pl0_TokKind[] = {
  1, 1, 1, 6, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2
};

static int pl0_NtClass[] = {
  0, 1, 1, 3, 3, 5, 6, 6, 
  8, 9, 9, 9, 9, 9, 14, 14
};

static c_bool pl0_ErrorNt[] = {
  0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0
};

static KFGHEAD pl0_KfgHead = {
  "pl0",
  18, 16, pl0_SNames,
  1, pl0_StartIds,
  pl0_TokKind,
  pl0_NtClass,
  pl0_ErrorNt
};

static int pl0_PSymbols[] = {
  19, 21,
  23, 20,
  23, 20,
  26, 22,
  26, 22,
  4, 2, 5, 24, 7, 8, 27,
  2, 25,
  6, 2, 25,
  9, 27,
  28,
  10, 28, 11, 27, 12, 27,
  29,
  29, 13, 29,
  29, 8, 29,
  30,
  29, 14, 30,
  29, 15, 30,
  31,
  30, 16, 31,
  30, 17, 31,
  15, 31,
  5, 27, 7,
  1,
  2,
  2, 5, 32, 7,
  27, 33,
  6, 27, 33,
  18
};

static int pl0_PSymFrms[] = {
  0, 12,
  0, -2,
  0, -2,
  0, -2,
  0, -2,
  0, 6, 10, 14, 31, 35, 39,
  0, -2,
  0, -4, -6,
  0, 6,
  0,
  0, 5, 10, 17, 21, 28,
  0,
  0, 5, 9,
  0, 5, 9,
  0,
  0, 5, 9,
  0, 5, 9,
  0,
  0, 5, 9,
  0, 5, 9,
  0, 4,
  0, 4, 8,
  0,
  0,
  0, 4, 8, 24,
  0, -2,
  0, -4, -6,
  0
};

static KFGPROD pl0_KfgProds[] = {
  { "pgm", 0, 18, 2, &pl0_PSymbols[0], &pl0_PSymFrms[0] },
  { "nil", 0, 19, 0, (int*)NULL, (int*)NULL },
  { "cons", 0, 19, 2, &pl0_PSymbols[2], &pl0_PSymFrms[2] },
  { "nil", 0, 20, 0, (int*)NULL, (int*)NULL },
  { "cons", 0, 20, 2, &pl0_PSymbols[4], &pl0_PSymFrms[4] },
  { "nil", 0, 21, 0, (int*)NULL, (int*)NULL },
  { "cons", 0, 21, 2, &pl0_PSymbols[6], &pl0_PSymFrms[6] },
  { "nil", 0, 22, 0, (int*)NULL, (int*)NULL },
  { "cons", 0, 22, 2, &pl0_PSymbols[8], &pl0_PSymFrms[8] },
  { "fun", 0, 23, 7, &pl0_PSymbols[10], &pl0_PSymFrms[10] },
  { "nil", 0, 24, 0, (int*)NULL, (int*)NULL },
  { "cons", 0, 24, 2, &pl0_PSymbols[17], &pl0_PSymFrms[17] },
  { "nil", 0, 25, 0, (int*)NULL, (int*)NULL },
  { "cons", 0, 25, 3, &pl0_PSymbols[19], &pl0_PSymFrms[19] },
  { "run", 0, 26, 2, &pl0_PSymbols[22], &pl0_PSymFrms[22] },
  { "ign0", 0, 27, 1, &pl0_PSymbols[24], &pl0_PSymFrms[24] },
  { "if", 0, 27, 6, &pl0_PSymbols[25], &pl0_PSymFrms[25] },
  { "ign0", 0, 28, 1, &pl0_PSymbols[31], &pl0_PSymFrms[31] },
  { "les", 0, 28, 3, &pl0_PSymbols[32], &pl0_PSymFrms[32] },
  { "equ", 0, 28, 3, &pl0_PSymbols[35], &pl0_PSymFrms[35] },
  { "ign0", 0, 29, 1, &pl0_PSymbols[38], &pl0_PSymFrms[38] },
  { "add", 0, 29, 3, &pl0_PSymbols[39], &pl0_PSymFrms[39] },
  { "sub", 0, 29, 3, &pl0_PSymbols[42], &pl0_PSymFrms[42] },
  { "ign0", 0, 30, 1, &pl0_PSymbols[45], &pl0_PSymFrms[45] },
  { "mlt", 0, 30, 3, &pl0_PSymbols[46], &pl0_PSymFrms[46] },
  { "div", 0, 30, 3, &pl0_PSymbols[49], &pl0_PSymFrms[49] },
  { "neg", 0, 31, 2, &pl0_PSymbols[52], &pl0_PSymFrms[52] },
  { "ign0", 0, 31, 3, &pl0_PSymbols[54], &pl0_PSymFrms[54] },
  { "int", 0, 31, 1, &pl0_PSymbols[57], &pl0_PSymFrms[57] },
  { "var", 0, 31, 1, &pl0_PSymbols[58], &pl0_PSymFrms[58] },
  { "app", 0, 31, 4, &pl0_PSymbols[59], &pl0_PSymFrms[59] },
  { "nil", 0, 32, 0, (int*)NULL, (int*)NULL },
  { "cons", 0, 32, 2, &pl0_PSymbols[63], &pl0_PSymFrms[63] },
  { "nil", 0, 33, 0, (int*)NULL, (int*)NULL },
  { "cons", 0, 33, 3, &pl0_PSymbols[65], &pl0_PSymFrms[65] },
  { "Start_Program", 0, 34, 1, &pl0_PSymbols[68], &pl0_PSymFrms[68] }
};

static int pl0_MstShifts[] = {
  1, 3, -1, 5, 1, 7, 13, -1, 
  5, -1, 1, 19, -1, 21, 13, 26, 
  26, -1, -1, 34, 40, -1, -1, 5, 
  -1, 43, 45, 13, 47, 49, -1, 26, 
  26, 26, 26, 26, 26, -1, 51, -1, 
  53, 55, 57, -1, 13, 60, 60, 40, 
  40, -1, -1, 43, 13, 13, -1, -1, 
  63, -1, -1, 55, 13, -1, -1
};

static int pl0_DtlShifts[] = {
  -2, 4, -6, 2, -7, 9, -12, 5, 
  -13, -14, -15, -16, -17, 15, 10, 5, 
  2, 1, -26, 2, -28, 5, -13, -14, 
  -15, -17, 15, 5, 2, 1, -32, -33, 
  -34, -35, 15, 14, 13, 8, -36, -37, 
  17, 16, -39, 6, -41, 7, -44, 7, 
  -45, 11, -52, 2, -53, 8, -54, 6, 
  -56, 7, -34, -35, 15, 14, -61, 12
};

static int pl0_GoTos[] = {
  0, 2, 4, 8, 10, 14, 19, 21, 
  25, 30, 44, 54, 67, 82, 101, 103
};

static int pl0_GoToDfts[] = {
  66, -1, 67, -1, 73, 5, 88, 11, 
  71, -4, 86, 9, 101, 24, 68, 1, 
  74, 5, 11, 90, -12, 103, 26, 121, 
  52, 72, 4, 87, 9, 24, 81, 7, 
  92, 15, 105, 28, 120, 45, 122, 53, 
  123, 54, 126, 61, 82, 7, 15, 28, 
  45, 53, 54, 61, 93, 16, 83, 7, 
  15, 16, 28, 45, 53, 54, 61, 109, 
  32, 110, 33, 84, 7, 15, 16, 28, 
  32, 33, 45, 53, 54, 61, 111, 34, 
  112, 35, 85, 7, 15, 16, 28, 32, 
  33, 34, 35, 45, 53, 54, 61, 94, 
  17, 113, 36, 114, 37, 106, -28, 118, 
  42, 125, 60
};

static int pl0_ActDfts[] = {
  2, 37, 38, 6, 4, 37, 37, 1, 
  8, 3, 4, 11, 29, 30, 37, 37, 
  37, 15, 16, 18, 21, 24, 7, 8, 
  5, 13, 37, 32, 37, 37, 27, 37, 
  37, 37, 37, 37, 37, 9, 37, 12, 
  37, 34, 37, 28, 37, 20, 19, 22, 
  23, 25, 26, 13, 37, 37, 33, 31, 
  37, 14, 10, 34, 37, 35, 17
};


static PARSETAB pl0_ParseTab = {
  &pl0_KfgHead, 36, pl0_KfgProds,
  {
    63, pl0_MstShifts, 64, pl0_DtlShifts,
    16, pl0_GoTos, 107, pl0_GoToDfts,
    63, pl0_ActDfts, 0, (int*)NULL
  }
};

PLR_Tab PLR_get_pl0()
/* simulates a PLR_getTab */
{
  return( PLR_copyTab(&pl0_ParseTab) );
}
